diff --git a/src/or/dirserv.c b/src/or/dirserv.c
index aa2e74b..a8bb780 100644
--- a/src/or/dirserv.c
+++ b/src/or/dirserv.c
@@ -71,7 +71,7 @@ static int add_fingerprint_to_dir(const char *nickname, const char *fp,
 static uint32_t
 dirserv_get_status_impl(const char *fp, const char *nickname,
                         const char *address,
-                        uint32_t addr, uint16_t or_port,
+                        const tor_addr_t *addr, uint16_t or_port,
                         const char *platform, const char *contact,
                         const char **msg, int should_log);
 static void clear_cached_dir(cached_dir_t *d);
@@ -319,7 +319,7 @@ dirserv_router_get_status(const routerinfo_t *router, const char **msg)
 
   return dirserv_get_status_impl(d, router->nickname,
                                  router->address,
-                                 router->addr, router->or_port,
+                                 &router->addr, router->or_port,
                                  router->platform, router->contact_info,
                                  msg, 1);
 }
@@ -333,7 +333,7 @@ dirserv_would_reject_router(const routerstatus_t *rs)
 
   res = dirserv_get_status_impl(rs->identity_digest, rs->nickname,
                                 "", /* address is only used in logs */
-                                rs->addr, rs->or_port,
+                                &rs->addr, rs->or_port,
                                 NULL, NULL,
                                 NULL, 0);
 
@@ -372,7 +372,7 @@ dirserv_get_name_status(const char *id_digest, const char *nickname)
 static uint32_t
 dirserv_get_status_impl(const char *id_digest, const char *nickname,
                         const char *address,
-                        uint32_t addr, uint16_t or_port,
+                        const tor_addr_t *addr, uint16_t or_port,
                         const char *platform, const char *contact,
                         const char **msg, int should_log)
 {
@@ -514,15 +514,15 @@ dirserv_free_fingerprint_list(void)
 static int
 dirserv_router_has_valid_address(routerinfo_t *ri)
 {
-  struct in_addr iaddr;
+  tor_addr_t iaddr;
   if (get_options()->DirAllowPrivateAddresses)
     return 0; /* whatever it is, we're fine with it */
-  if (!tor_inet_aton(ri->address, &iaddr)) {
+  if (!tor_inet_pton(AF_UNSPEC, ri->address, &iaddr)) {
     log_info(LD_DIRSERV,"Router '%s' published non-IP address '%s'. Refusing.",
              ri->nickname, ri->address);
     return -1;
   }
-  if (is_internal_IP(ntohl(iaddr.s_addr), 0)) {
+  if (tor_addr_is_internal(&iaddr,0)) {
     log_info(LD_DIRSERV,
              "Router '%s' published internal IP address '%s'. Refusing.",
              ri->nickname, ri->address);
@@ -1196,7 +1196,7 @@ int
 directory_fetches_from_authorities(or_options_t *options)
 {
   const routerinfo_t *me;
-  uint32_t addr;
+  tor_addr_t addr;
   int refuseunknown;
   if (options->FetchDirInfoEarly)
     return 1;
@@ -2044,7 +2044,7 @@ routerstatus_format_entry(char *buf, size_t buf_len,
                    (format==NS_V3_CONSENSUS_MICRODESC)?"":digest64,
                    (format==NS_V3_CONSENSUS_MICRODESC)?"":" ",
                    published,
-                   fmt_addr32(rs->addr),
+                   fmt_addr(&rs->addr),
                    (int)rs->or_port,
                    (int)rs->dir_port);
   if (r<0) {
@@ -2188,17 +2188,15 @@ static int
 _compare_routerinfo_by_ip_and_bw(const void **a, const void **b)
 {
   routerinfo_t *first = *(routerinfo_t **)a, *second = *(routerinfo_t **)b;
-  int first_is_auth, second_is_auth;
+  int first_is_auth, second_is_auth, n;
   uint32_t bw_first, bw_second;
   const node_t *node_first, *node_second;
   int first_is_running, second_is_running;
 
   /* we return -1 if first should appear before second... that is,
    * if first is a better router. */
-  if (first->addr < second->addr)
-    return -1;
-  else if (first->addr > second->addr)
-    return 1;
+  n = tor_addr_cmp(&first->addr, &second->addr);
+  if (n != 0) return n;
 
   /* Potentially, this next bit could cause k n lg n memcmp calls.  But in
    * reality, we will almost never get here, since addresses will usually be
@@ -2248,7 +2246,7 @@ get_possible_sybil_list(const smartlist_t *routers)
   or_options_t *options = get_options();
   digestmap_t *omit_as_sybil;
   smartlist_t *routers_by_ip = smartlist_create();
-  uint32_t last_addr;
+  tor_addr_t last_addr;
   int addr_count;
   /* Allow at most this number of Tor servers on a single IP address, ... */
   int max_with_same_addr = options->AuthDirMaxServersPerAddr;
@@ -2263,15 +2261,15 @@ get_possible_sybil_list(const smartlist_t *routers)
   smartlist_sort(routers_by_ip, _compare_routerinfo_by_ip_and_bw);
   omit_as_sybil = digestmap_new();
 
-  last_addr = 0;
+  tor_addr_from_null(&last_addr);
   addr_count = 0;
   SMARTLIST_FOREACH(routers_by_ip, routerinfo_t *, ri,
     {
-      if (last_addr != ri->addr) {
-        last_addr = ri->addr;
+      if (!tor_addr_eq(&last_addr, &ri->addr)) {
+        tor_addr_copy(&last_addr, &ri->addr);
         addr_count = 1;
       } else if (++addr_count > max_with_same_addr) {
-        if (!router_addr_is_trusted_dir(ri->addr) ||
+        if (!router_addr_is_trusted_dir(&ri->addr) ||
             addr_count > max_with_same_addr_on_authority)
           digestmap_set(omit_as_sybil, ri->cache_info.identity_digest, ri);
       }
@@ -2547,7 +2545,7 @@ dirserv_generate_networkstatus_vote_obj(crypto_pk_env_t *private_key,
 {
   or_options_t *options = get_options();
   networkstatus_t *v3_out = NULL;
-  uint32_t addr;
+  tor_addr_t addr;
   char *hostname = NULL, *client_versions = NULL, *server_versions = NULL;
   const char *contact;
   smartlist_t *routers, *routerstatuses;
@@ -2574,7 +2572,7 @@ dirserv_generate_networkstatus_vote_obj(crypto_pk_env_t *private_key,
   }
   if (!strchr(hostname, '.')) {
     tor_free(hostname);
-    hostname = tor_dup_ip(addr);
+    hostname = tor_dup_ip(&addr);
   }
   if (crypto_pk_get_digest(private_key, signing_key_digest)<0) {
     log_err(LD_BUG, "Error computing signing key digest");
@@ -2764,7 +2762,7 @@ generate_v2_networkstatus_opinion(void)
   char fingerprint[FINGERPRINT_LEN+1];
   char published[ISO_TIME_LEN+1];
   char digest[DIGEST_LEN];
-  uint32_t addr;
+  tor_addr_t addr;
   crypto_pk_env_t *private_key;
   routerlist_t *rl = router_get_routerlist();
   time_t now = time(NULL);
@@ -2829,7 +2827,7 @@ generate_v2_networkstatus_opinion(void)
                "dir-options%s%s%s%s\n"
                "%s" /* client version line, server version line. */
                "dir-signing-key\n%s",
-               hostname, fmt_addr32(addr),
+               hostname, fmt_addr(&addr),
                (int)router_get_advertised_dir_port(options),
                fingerprint,
                contact,
@@ -3237,14 +3235,12 @@ dirserv_should_launch_reachability_test(const routerinfo_t *ri,
 void
 dirserv_single_reachability_test(time_t now, routerinfo_t *router)
 {
-  tor_addr_t router_addr;
   log_debug(LD_OR,"Testing reachability of %s at %s:%u.",
             router->nickname, router->address, router->or_port);
   /* Remember when we started trying to determine reachability */
   if (!router->testing_since)
     router->testing_since = now;
-  tor_addr_from_ipv4h(&router_addr, router->addr);
-  connection_or_connect(&router_addr, router->or_port,
+  connection_or_connect(&router->addr, router->or_port,
                         router->cache_info.identity_digest);
 }
 
diff --git a/src/or/dirvote.c b/src/or/dirvote.c
index 6fe29f2..8308d95 100644
--- a/src/or/dirvote.c
+++ b/src/or/dirvote.c
@@ -84,7 +84,6 @@ format_networkstatus_vote(crypto_pk_env_t *private_signing_key,
   char *outp, *endp;
   char fingerprint[FINGERPRINT_LEN+1];
   char digest[DIGEST_LEN];
-  uint32_t addr;
   routerlist_t *rl = router_get_routerlist();
   char *version_lines = NULL;
   int r;
@@ -95,8 +94,6 @@ format_networkstatus_vote(crypto_pk_env_t *private_signing_key,
 
   voter = smartlist_get(v3_ns->voters, 0);
 
-  addr = voter->addr;
-
   base16_encode(fingerprint, sizeof(fingerprint),
                 v3_ns->cert->cache_info.identity_digest, DIGEST_LEN);
   client_versions = v3_ns->client_versions;
@@ -182,7 +179,7 @@ format_networkstatus_vote(crypto_pk_env_t *private_signing_key,
                  flags,
                  params,
                  voter->nickname, fingerprint, voter->address,
-                 fmt_addr32(addr), voter->dir_port, voter->or_port,
+                 fmt_addr(&voter->addr), voter->dir_port, voter->or_port,
                  voter->contact);
 
     if (r < 0) {
@@ -401,7 +398,7 @@ compare_vote_rs(const vote_routerstatus_t *a, const vote_routerstatus_t *b)
     return r;
   if ((r = strcmp(b->status.nickname, a->status.nickname)))
     return r;
-  if ((r = (((int)b->status.addr) - ((int)a->status.addr))))
+  if ((r = tor_addr_cmp(&b->status.addr, &a->status.addr)))
     return r;
   if ((r = (((int)b->status.or_port) - ((int)a->status.or_port))))
     return r;
@@ -1542,7 +1539,7 @@ networkstatus_compute_consensus(smartlist_t *votes,
       tor_asprintf(&buf,
                    "dir-source %s%s %s %s %s %d %d\n",
                    voter->nickname, e->is_legacy ? "-legacy" : "",
-                   fingerprint, voter->address, fmt_addr32(voter->addr),
+                   fingerprint, voter->address, fmt_addr(&voter->addr),
                    voter->dir_port,
                    voter->or_port);
       smartlist_add(chunks, buf);
diff --git a/src/or/dns.c b/src/or/dns.c
index c8e1012..557368f 100644
--- a/src/or/dns.c
+++ b/src/or/dns.c
@@ -1204,8 +1204,7 @@ configure_nameservers(int force)
     } else {
       int socklen;
       struct sockaddr_storage ss;
-      socklen = tor_addr_to_sockaddr(&addr, 0,
-                                     (struct sockaddr *)&ss, sizeof(ss));
+      socklen = tor_addr_to_sockaddr(&addr, 0, &ss, sizeof(ss));
       if (socklen <= 0) {
         log_warn(LD_BUG, "Couldn't convert outbound bind address to sockaddr."
                  " Ignoring.");
diff --git a/src/or/eventdns.c b/src/or/eventdns.c
index fb05e48..2060a06 100644
--- a/src/or/eventdns.c
+++ b/src/or/eventdns.c
@@ -359,7 +359,6 @@ error_is_eagain(int err)
 {
 	return err == EAGAIN || err == WSAEWOULDBLOCK;
 }
-#define inet_aton(c, addr) tor_inet_aton((c), (addr))
 #define CLOSE_SOCKET(x) closesocket(x)
 #else
 #define last_error(sock) (errno)
@@ -2288,7 +2287,7 @@ _evdns_nameserver_add_impl(const struct sockaddr *address,
 
 	evtimer_set(&ns->timeout_event, nameserver_prod_callback, ns);
 
-	ns->socket = tor_open_socket(PF_INET, SOCK_DGRAM, 0);
+	ns->socket = tor_open_socket(address->sa_family == AF_INET ? PF_INET : PF_INET6, SOCK_DGRAM, 0);
 	if (ns->socket < 0) { err = 1; goto out1; }
 #ifdef WIN32
 	{
@@ -2299,6 +2298,8 @@ _evdns_nameserver_add_impl(const struct sockaddr *address,
 	fcntl(ns->socket, F_SETFL, O_NONBLOCK);
 #endif
 
+	/* XXX Check that global_bind_address matches socket family before comparing */
+
 	if (global_bind_addr_is_set &&
 	    !sockaddr_is_loopback((struct sockaddr*)&global_bind_address)) {
 		if (bind(ns->socket, (struct sockaddr *)&global_bind_address,
@@ -2352,7 +2353,7 @@ out1:
 	return err;
 }
 
-/* exported function */
+/* exported function */ /* XXX-IPv6: Unused in Tor */
 int
 evdns_nameserver_add(uint32_t address) {
 	struct sockaddr_in sin;
@@ -2372,7 +2373,9 @@ evdns_nameserver_ip_add(const char *ip_as_string) {
 	int port;
 	char buf[128];
 	const char *cp, *addr_part, *port_part;
-	int is_ipv6;
+        tor_addr_t addr;
+        struct sockaddr_storage sa;
+        socklen_t sa_len;
 	/* recognized formats are:
 	 * [ipv6]:port
 	 * ipv6
@@ -2402,13 +2405,10 @@ evdns_nameserver_ip_add(const char *ip_as_string) {
 			port_part = cp+2;
 		else
 			port_part = NULL;
-		is_ipv6 = 1;
 	} else if (cp && strchr(cp+1, ':')) {
-		is_ipv6 = 1;
 		addr_part = ip_as_string;
 		port_part = NULL;
 	} else if (cp) {
-		is_ipv6 = 0;
 		if (cp - ip_as_string > (int)sizeof(buf)-1) {
 			log(EVDNS_LOG_DEBUG, "Nameserver does not fit in buffer.");
 			return 4;
@@ -2420,7 +2420,6 @@ evdns_nameserver_ip_add(const char *ip_as_string) {
 	} else {
 		addr_part = ip_as_string;
 		port_part = NULL;
-		is_ipv6 = 0;
 	}
 
 	if (port_part == NULL) {
@@ -2434,37 +2433,14 @@ evdns_nameserver_ip_add(const char *ip_as_string) {
 		}
 	}
 
-	/* Tor-only.  needs a more general fix. */
+	/* Tor-only.  needs a more general fix (XXX-IPv6: Like rewriting the whole evdns part? :) */
 	assert(addr_part);
-	if (is_ipv6) {
-		struct sockaddr_in6 sin6;
-		memset(&sin6, 0, sizeof(sin6));
-#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
-		sin6.sin6_len = sizeof(sin6);
-#endif
-		sin6.sin6_family = AF_INET6;
-		sin6.sin6_port = htons(port);
-		if (1 != tor_inet_pton(AF_INET6, addr_part, &sin6.sin6_addr)) {
-			log(EVDNS_LOG_DEBUG, "inet_pton(%s) failed", addr_part);
-			return 4;
-		}
-		return _evdns_nameserver_add_impl((struct sockaddr*)&sin6,
-										  sizeof(sin6));
-	} else {
-		struct sockaddr_in sin;
-		memset(&sin, 0, sizeof(sin));
-#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
-		sin.sin_len = sizeof(sin);
-#endif
-		sin.sin_family = AF_INET;
-		sin.sin_port = htons(port);
-		if (!inet_aton(addr_part, &sin.sin_addr)) {
-			log(EVDNS_LOG_DEBUG, "inet_pton(%s) failed", addr_part);
-			return 4;
-		}
-		return _evdns_nameserver_add_impl((struct sockaddr*)&sin,
-										  sizeof(sin));
+        if (1 != tor_inet_pton(AF_UNSPEC, addr_part, &addr)) {
+		log(EVDNS_LOG_DEBUG, "tor_inet_pton(%s) failed", addr_part);
+		return 4;
 	}
+        sa_len = tor_addr_to_sockaddr(&addr, 0, &sa, sizeof(sa));
+	return _evdns_nameserver_add_impl((struct sockaddr*)&sa, sa_len);
 }
 
 int
@@ -3470,13 +3446,14 @@ main(int c, char **v) {
 	}
 	for (; idx < c; ++idx) {
 		if (reverse) {
-			struct in_addr addr;
-			if (!inet_aton(v[idx], &addr)) {
+                        tor_addr_t addr;
+			if (!inet_pton(AF_UNSPEC, v[idx], &addr)) {
 				fprintf(stderr, "Skipping non-IP %s\n", v[idx]);
 				continue;
 			}
 			fprintf(stderr, "resolving %s...\n",v[idx]);
-			evdns_resolve_reverse(&addr, 0, main_callback, v[idx]);
+			if (tor_addr_family(&addr) == AF_INET) evdns_resolve_reverse(&addr.in_addr, 0, main_callback, v[idx]);
+			else evdns_resolve_reverse6(&addr.in6_addr, 0, main_callback, v[idx]);
 		} else {
 			fprintf(stderr, "resolving (fwd) %s...\n",v[idx]);
 			evdns_resolve_ipv4(v[idx], 0, main_callback, v[idx]);
diff --git a/src/or/geoip.c b/src/or/geoip.c
index 71ed3be..834ea72 100644
--- a/src/or/geoip.c
+++ b/src/or/geoip.c
@@ -23,8 +23,8 @@ static void init_geoip_countries(void);
 
 /** An entry from the GeoIP file: maps an IP range to a country. */
 typedef struct geoip_entry_t {
-  uint32_t ip_low; /**< The lowest IP in the range, in host order */
-  uint32_t ip_high; /**< The highest IP in the range, in host order */
+  tor_addr_t ip_low; /**< The lowest IP in the range, in host order */
+  tor_addr_t ip_high; /**< The highest IP in the range, in host order */
   intptr_t country; /**< An index into geoip_countries */
 } geoip_entry_t;
 
@@ -68,13 +68,14 @@ geoip_get_country(const char *country)
  * <b>high</b>, inclusive, to the 2-letter country code <b>country</b>.
  */
 static void
-geoip_add_entry(uint32_t low, uint32_t high, const char *country)
+geoip_add_entry(tor_addr_t *low, tor_addr_t *high, const char *country)
 {
   intptr_t idx;
   geoip_entry_t *ent;
   void *_idxplus1;
 
-  if (high < low)
+  tor_assert(tor_addr_cmp(low, high) <= 1);
+  if (tor_addr_cmp(low, high) > 1)
     return;
 
   _idxplus1 = strmap_get_lc(country_idxplus1_by_lc_code, country);
@@ -94,18 +95,21 @@ geoip_add_entry(uint32_t low, uint32_t high, const char *country)
     tor_assert(!strcasecmp(c->countrycode, country));
   }
   ent = tor_malloc_zero(sizeof(geoip_entry_t));
-  ent->ip_low = low;
-  ent->ip_high = high;
+  memcpy(&ent->ip_low, &low,  sizeof(*low));
+  memcpy(&ent->ip_high,&high, sizeof(*high));
   ent->country = idx;
   smartlist_add(geoip_entries, ent);
 }
 
+/* XXX-IPv6: Only loads IPv4 file, we don't have IPv6 entries yet anyway */
+/* XXX-IPv6: These files should be prefix based (eg 192.0.2.0/24 and 2001:db8::/32) */
 /** Add an entry to the GeoIP table, parsing it from <b>line</b>.  The
  * format is as for geoip_load_file(). */
 /*private*/ int
 geoip_parse_entry(const char *line)
 {
-  unsigned int low, high;
+  tor_addr_t lo, hi;
+  uint32_t l,h;
   char b[3];
   if (!geoip_countries)
     init_geoip_countries();
@@ -116,11 +120,15 @@ geoip_parse_entry(const char *line)
     ++line;
   if (*line == '#')
     return 0;
-  if (sscanf(line,"%u,%u,%2s", &low, &high, b) == 3) {
-    geoip_add_entry(low, high, b);
+  if (sscanf(line,"%u,%u,%2s", &l, &h, b) == 3) {
+    tor_addr_from_ipv4h(&lo, l);
+    tor_addr_from_ipv4h(&hi, h);
+    geoip_add_entry(&lo, &hi, b);
     return 0;
-  } else if (sscanf(line,"\"%u\",\"%u\",\"%2s\",", &low, &high, b) == 3) {
-    geoip_add_entry(low, high, b);
+  } else if (sscanf(line,"\"%u\",\"%u\",\"%2s\",", &l, &h, b) == 3) {
+    tor_addr_from_ipv4h(&lo, l);
+    tor_addr_from_ipv4h(&hi, h);
+    geoip_add_entry(&lo, &hi, b);
     return 0;
   } else {
     log_warn(LD_GENERAL, "Unable to parse line from GEOIP file: %s",
@@ -135,28 +143,19 @@ static int
 _geoip_compare_entries(const void **_a, const void **_b)
 {
   const geoip_entry_t *a = *_a, *b = *_b;
-  if (a->ip_low < b->ip_low)
-    return -1;
-  else if (a->ip_low > b->ip_low)
-    return 1;
-  else
-    return 0;
+  return tor_addr_cmp(&a->ip_low, &b->ip_low);
 }
 
-/** bsearch helper: return -1, 1, or 0 based on comparison of an IP (a pointer
- * to a uint32_t in host order) to a geoip_entry_t */
+/** bsearch helper: return -1, 1, or 0 based on comparison of an
+ * IP (a pointer * to a tor_addr_t) to a geoip_entry_t */
 static int
 _geoip_compare_key_to_entry(const void *_key, const void **_member)
 {
-  /* No alignment issue here, since _key really is a pointer to uint32_t */
-  const uint32_t addr = *(uint32_t *)_key;
+  /* No alignment issue here, since _key really is a pointer to tor_addr_t */
+  const tor_addr_t *addr = (tor_addr_t *)_key;
   const geoip_entry_t *entry = *_member;
-  if (addr < entry->ip_low)
-    return -1;
-  else if (addr > entry->ip_high)
-    return 1;
-  else
-    return 0;
+
+  return tor_addr_cmp(addr, &entry->ip_low);
 }
 
 /** Return 1 if we should collect geoip stats on bridge users, and
@@ -252,12 +251,16 @@ geoip_load_file(const char *filename, or_options_t *options)
  * geoip_get_country_name().
  */
 int
-geoip_get_country_by_ip(uint32_t ipaddr)
+geoip_get_country_by_ip(const tor_addr_t *ipaddr)
 {
   geoip_entry_t *ent;
   if (!geoip_entries)
     return -1;
-  ent = smartlist_bsearch(geoip_entries, &ipaddr, _geoip_compare_key_to_entry);
+  /* XXX-IPv6: dirty, should maybe just make tor_addr_t just hold an address
+   * as that is the information we need in there, not in_addr
+   * then it satisfies the minimum memory usage which geoip needs
+   */
+  ent = smartlist_bsearch(geoip_entries, tor_addr_raw(ipaddr), _geoip_compare_key_to_entry);
   return ent ? (int)ent->country : 0;
 }
 
@@ -303,7 +306,7 @@ geoip_db_digest(void)
  * countries have them blocked. */
 typedef struct clientmap_entry_t {
   HT_ENTRY(clientmap_entry_t) node;
-  uint32_t ipaddr;
+  tor_addr_t ipaddr;
   /** Time when we last saw this IP address, in MINUTES since the epoch.
    *
    * (This will run out of space around 4011 CE.  If Tor is still in use around
@@ -325,13 +328,14 @@ static HT_HEAD(clientmap, clientmap_entry_t) client_history =
 static INLINE unsigned
 clientmap_entry_hash(const clientmap_entry_t *a)
 {
-  return ht_improve_hash((unsigned) a->ipaddr);
+  /* XXX-IPv6: need to see how to properly handle this */
+  return ht_improve_hash((unsigned) tor_addr_to_ipv4h(&a->ipaddr));
 }
 /** Hashtable helper: compare two clientmap_entry_t values for equality. */
 static INLINE int
 clientmap_entries_eq(const clientmap_entry_t *a, const clientmap_entry_t *b)
 {
-  return a->ipaddr == b->ipaddr && a->action == b->action;
+  return tor_addr_eq(&a->ipaddr,&b->ipaddr) && a->action == b->action;
 }
 
 HT_PROTOTYPE(clientmap, clientmap_entry_t, node, clientmap_entry_hash,
@@ -422,7 +426,7 @@ geoip_get_mean_shares(time_t now, double *v2_share_out,
  * configured accordingly. */
 void
 geoip_note_client_seen(geoip_client_action_t action,
-                       uint32_t addr, time_t now)
+                       tor_addr_t *addr, time_t now)
 {
   or_options_t *options = get_options();
   clientmap_entry_t lookup, *ent;
@@ -437,12 +441,12 @@ geoip_note_client_seen(geoip_client_action_t action,
       return;
   }
 
-  lookup.ipaddr = addr;
+  tor_addr_copy(&lookup.ipaddr, addr);
   lookup.action = (int)action;
   ent = HT_FIND(clientmap, &client_history, &lookup);
   if (! ent) {
     ent = tor_malloc_zero(sizeof(clientmap_entry_t));
-    ent->ipaddr = addr;
+    tor_addr_copy(&ent->ipaddr, addr);
     ent->action = (int)action;
     HT_INSERT(clientmap, &client_history, ent);
   }
@@ -823,7 +827,7 @@ geoip_get_client_history(geoip_client_action_t action)
     int country;
     if ((*ent)->action != (int)action)
       continue;
-    country = geoip_get_country_by_ip((*ent)->ipaddr);
+    country = geoip_get_country_by_ip(&(*ent)->ipaddr);
     if (country < 0)
       country = 0; /** unresolved requests are stored at index 0. */
     tor_assert(0 <= country && country < n_countries);
@@ -1364,12 +1368,10 @@ getinfo_helper_geoip(control_connection_t *control_conn,
   }
   if (!strcmpstart(question, "ip-to-country/")) {
     int c;
-    uint32_t ip;
-    struct in_addr in;
+    tor_addr_t a;
     question += strlen("ip-to-country/");
-    if (tor_inet_aton(question, &in) != 0) {
-      ip = ntohl(in.s_addr);
-      c = geoip_get_country_by_ip(ip);
+    if (tor_inet_pton(AF_UNSPEC, question, &a) != 0) {
+      c = geoip_get_country_by_ip(&a);
       *answer = tor_strdup(geoip_get_country_name(c));
     }
   }
diff --git a/src/or/geoip.h b/src/or/geoip.h
index 02228ea..50351a8 100644
--- a/src/or/geoip.h
+++ b/src/or/geoip.h
@@ -17,7 +17,7 @@ int geoip_parse_entry(const char *line);
 #endif
 int should_record_bridge_info(or_options_t *options);
 int geoip_load_file(const char *filename, or_options_t *options);
-int geoip_get_country_by_ip(uint32_t ipaddr);
+int geoip_get_country_by_ip(const tor_addr_t *ipaddr);
 int geoip_get_n_countries(void);
 const char *geoip_get_country_name(country_t num);
 int geoip_is_loaded(void);
@@ -25,7 +25,7 @@ const char *geoip_db_digest(void);
 country_t geoip_get_country(const char *countrycode);
 
 void geoip_note_client_seen(geoip_client_action_t action,
-                            uint32_t addr, time_t now);
+                            tor_addr_t *addr, time_t now);
 void geoip_remove_old_clients(time_t cutoff);
 
 void geoip_note_ns_response(geoip_client_action_t action,
diff --git a/src/or/networkstatus.c b/src/or/networkstatus.c
index 837c8c2..6a215bd 100644
--- a/src/or/networkstatus.c
+++ b/src/or/networkstatus.c
@@ -1131,15 +1131,13 @@ update_v2_networkstatus_cache_downloads(time_t now)
     SMARTLIST_FOREACH_BEGIN(trusted_dir_servers, trusted_dir_server_t *, ds)
       {
          char resource[HEX_DIGEST_LEN+6]; /* fp/hexdigit.z\0 */
-         tor_addr_t addr;
          if (!(ds->type & V2_DIRINFO))
            continue;
          if (router_digest_is_me(ds->digest))
            continue;
-         tor_addr_from_ipv4h(&addr, ds->addr);
          /* Is this quite sensible with IPv6 or multiple addresses? */
          if (connection_get_by_type_addr_port_purpose(
-                CONN_TYPE_DIR, &addr, ds->dir_port,
+                CONN_TYPE_DIR, &ds->addr, ds->dir_port,
                 DIR_PURPOSE_FETCH_V2_NETWORKSTATUS)) {
            /* XXX the above dir_port won't be accurate if we're
             * doing a tunneled conn. In that case it should be or_port.
@@ -1471,7 +1469,7 @@ routerstatus_has_changed(const routerstatus_t *a, const routerstatus_t *b)
 
   return strcmp(a->nickname, b->nickname) ||
          fast_memneq(a->descriptor_digest, b->descriptor_digest, DIGEST_LEN) ||
-         a->addr != b->addr ||
+         tor_addr_eq(&a->addr, &b->addr) ||
          a->or_port != b->or_port ||
          a->dir_port != b->dir_port ||
          a->is_authority != b->is_authority ||
diff --git a/src/or/nodelist.c b/src/or/nodelist.c
index 0856b31..b9c8ee3 100644
--- a/src/or/nodelist.c
+++ b/src/or/nodelist.c
@@ -621,31 +621,17 @@ node_exit_policy_rejects_all(const node_t *node)
     return 1;
 }
 
-/** Copy the address for <b>node</b> into *<b>addr_out</b>. */
-int
-node_get_addr(const node_t *node, tor_addr_t *addr_out)
-{
-  if (node->ri) {
-    tor_addr_from_ipv4h(addr_out, node->ri->addr);
-    return 0;
-  } else if (node->rs) {
-    tor_addr_from_ipv4h(addr_out, node->rs->addr);
-    return 0;
-  }
-  return -1;
-}
-
-/** Return the host-order IPv4 address for <b>node</b>, or 0 if it doesn't
+/** Return the tor_addr_t for <b>node</b>, or 0 if it doesn't
  * seem to have one.  */
-uint32_t
-node_get_addr_ipv4h(const node_t *node)
+const tor_addr_t *
+node_get_addr(const node_t *node)
 {
   if (node->ri) {
-    return node->ri->addr;
+    return &node->ri->addr;
   } else if (node->rs) {
-    return node->rs->addr;
+    return &node->rs->addr;
   }
-  return 0;
+  return NULL;
 }
 
 /** Copy a string representation of the IP address for <b>node</b> into the
@@ -657,9 +643,7 @@ node_get_address_string(const node_t *node, char *buf, size_t len)
   if (node->ri) {
     strlcpy(buf, node->ri->address, len);
   } else if (node->rs) {
-    tor_addr_t addr;
-    tor_addr_from_ipv4h(&addr, node->rs->addr);
-    tor_addr_to_str(buf, &addr, len, 0);
+    tor_addr_to_str(&node->rs->addr, buf, len, 0);
   } else {
     buf[0] = '\0';
   }
diff --git a/src/or/nodelist.h b/src/or/nodelist.h
index 08f11da..2dc9920 100644
--- a/src/or/nodelist.h
+++ b/src/or/nodelist.h
@@ -37,8 +37,7 @@ int node_get_purpose(const node_t *node);
   (node_get_purpose((node)) == ROUTER_PURPOSE_BRIDGE)
 int node_is_me(const node_t *node);
 int node_exit_policy_rejects_all(const node_t *node);
-int node_get_addr(const node_t *node, tor_addr_t *addr_out);
-uint32_t node_get_addr_ipv4h(const node_t *node);
+const tor_addr_t *node_get_addr(const node_t *node);
 int node_allows_single_hop_exits(const node_t *node);
 uint16_t node_get_orport(const node_t *node);
 const char *node_get_nickname(const node_t *node);
diff --git a/src/or/or.h b/src/or/or.h
index 74b0244..f92acde 100644
--- a/src/or/or.h
+++ b/src/or/or.h
@@ -1505,7 +1505,7 @@ typedef struct {
   char *address; /**< Location of OR: either a hostname or an IP address. */
   char *nickname; /**< Human-readable OR name. */
 
-  uint32_t addr; /**< IPv4 address of OR, in host order. */
+  tor_addr_t addr; /**< IPv4 address of OR. */
   uint16_t or_port; /**< Port for TLS connections. */
   uint16_t dir_port; /**< Port for HTTP directory connections. */
 
@@ -1599,7 +1599,7 @@ typedef struct routerstatus_t {
   /** Digest of the router's most recent descriptor or microdescriptor.
    * If it's a descriptor, we only use the first DIGEST_LEN bytes. */
   char descriptor_digest[DIGEST256_LEN];
-  uint32_t addr; /**< IPv4 address for this router. */
+  tor_addr_t addr; /**< IPv4 address for this router. */
   uint16_t or_port; /**< OR port for this router. */
   uint16_t dir_port; /**< Directory port for this router. */
   unsigned int is_authority:1; /**< True iff this router is an authority. */
@@ -1820,7 +1820,7 @@ typedef struct networkstatus_v2_t {
   time_t published_on; /**< Declared publication date. */
 
   char *source_address; /**< Canonical directory server hostname. */
-  uint32_t source_addr; /**< Canonical directory server IP. */
+  tor_addr_t source_addr; /**< Canonical directory server IP. */
   uint16_t source_dirport; /**< Canonical directory server dirport. */
 
   unsigned int binds_names:1; /**< True iff this directory server binds
@@ -1895,7 +1895,7 @@ typedef struct networkstatus_voter_info_t {
    * consensuses, we treat legacy keys as additional signers. */
   char legacy_id_digest[DIGEST_LEN];
   char *address; /**< Address of this voter, in string format. */
-  uint32_t addr; /**< Address of this voter, in IPv4, in host order. */
+  tor_addr_t addr; /**< Address of this voter, in IPv4, in host order. */
   uint16_t dir_port; /**< Directory port of this voter */
   uint16_t or_port; /**< OR port of this voter */
   char *contact; /**< Contact information for this voter. */
@@ -2082,7 +2082,7 @@ typedef struct authority_cert_t {
   /** The listed expiration time of this certificate. */
   time_t expires;
   /** This authority's IPv4 address, in host order. */
-  uint32_t addr;
+  tor_addr_t addr;
   /** This authority's directory port. */
   uint16_t dir_port;
   /** True iff this certificate was cross-certified by signing the identity
@@ -3660,7 +3660,7 @@ typedef struct trusted_dir_server_t {
   char *description;
   char *nickname;
   char *address; /**< Hostname. */
-  uint32_t addr; /**< IPv4 address. */
+  tor_addr_t addr; /**< IPv4 address. */
   uint16_t dir_port; /**< Directory port. */
   uint16_t or_port; /**< OR port: Used for tunneling connections. */
   char digest[DIGEST_LEN]; /**< Digest of identity key. */
